<template>
  <article class="post">
    <div class="post-preview">
      <img :src="post.thumbnail" alt="Post Image" />
      <h1>{{ post.title }}</h1>
      <div class="post-priview">
        {{ post.previewText }}
      </div>
      <div class="post-updated">
        Author: {{ post.author }} | Published:
        <span>{{ post.updatedDate | timeAgo }} ago</span>
      </div>
      <div class="post-content">{{ post.content }}</div>
    </div>
  </article>
</template>

<script>
import FireStoreParser from 'firestore-parser'
export default {
  asyncData(context) {
    const structuredQuery = {
      from: [
        {
          collectionId: 'posts',
        },
      ],
      where: {
        fieldFilter: {
          field: {
            fieldPath: 'slug',
          },
          op: 'EQUAL',
          value: {
            stringValue: context.params.slug,
          },
        },
      },
    }
    return context.app.$axios
      .post(
        'https://firestore.googleapis.com/v1/projects/my-awesome-nuxt-project/databases/(default)/documents/:runQuery',
        { structuredQuery }
      )
      .then((result) => {
        const data = FireStoreParser(result.data[0])
        const post = {
          ...data.document.fields,
          id: data.document.name.substring(
            data.document.name.lastIndexOf('/' + 1)
          ),
        }
        return { post }
      })
      .catch((error) => {
        // eslint-disable-next-line no-console
        console.error(error)
      })
  },
}
</script>
<style scoped>
.post {
  display: flex;
  justify-content: center;
  max-width: 800px;
  margin: 0 auto;
  position: relative;
}
.post-updated {
  margin: 10px 0px;
}
</style>
